Attribute VB_Name = "SetResolution_module"
Declare Function EnumDisplaySettings Lib "user32" Alias _
                "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, _
                                        ByVal iModeNum As Long, _
                                        lptypDevMode As Any) As Boolean

Declare Function ChangeDisplaySettings Lib "user32" Alias _
                "ChangeDisplaySettingsA" (lptypDevMode As Any, _
                                          ByVal dwFlags As Long) As Long

Public Const EWX_LOGOFF = 0
Public Const EWX_SHUTDOWN = 1
Public Const EWX_REBOOT = 2
Public Const EWX_FORCE = 4
Public Const CCDEVICENAME = 32
Public Const CCFORMNAME = 32
Public Const DM_BITSPERPEL = &H40000
Public Const DM_PELSWIDTH = &H80000
Public Const DM_PELSHEIGHT = &H100000
Public Const CDS_UPDATEREGISTRY = &H1
Public Const CDS_TEST = &H4
Public Const DISP_CHANGE_SUCCESSFUL = 0
Public Const DISP_CHANGE_RESTART = 1
Public Const DM_DISPLAYFREQUENCY = &H400000
Public Const ENUM_CURRENT_SETTINGS = -1

Public Type typDevMODE
    dmDeviceName       As String * CCDEVICENAME
    dmSpecVersion      As Integer
    dmDriverVersion    As Integer
    dmSize             As Integer
    dmDriverExtra      As Integer
    dmFields           As Long
    dmOrientation      As Integer
    dmPaperSize        As Integer
    dmPaperLength      As Integer
    dmPaperWidth       As Integer
    dmScale            As Integer
    dmCopies           As Integer
    dmDefaultSource    As Integer
    dmPrintQuality     As Integer
    dmColor            As Integer
    dmDuplex           As Integer
    dmYResolution      As Integer
    dmTTOption         As Integer
    dmCollate          As Integer
    dmFormName         As String * CCFORMNAME
    dmUnusedPadding    As Integer
    dmBitsPerPel       As Integer
    dmPelsWidth        As Long
    dmPelsHeight       As Long
    dmDisplayFlags     As Long
    dmDisplayFrequency As Long
End Type
Public Sub SetResolution(ByVal w, ByVal h, ByVal OldFreq)
    On Error Resume Next
    Dim typDevM As typDevMODE
    Dim lngResult As Long
    Dim intAns As Integer
    '
    lngResult = EnumDisplaySettings(0, 0, typDevM)
    '
    With typDevM
        .dmFields = DM_PELSWIDTH Or DM_PELSHEIGHT Or DM_DISPLAYFREQUENCY
        .dmPelsWidth = w
        .dmPelsHeight = h
        .dmDisplayFrequency = OldFreq
    End With

    DoEvents
    lngResult = ChangeDisplaySettings(typDevM, 0)
    DoEvents
End Sub


